/*
 * Copyright (c) 1998 The Santa Cruz Operation, Inc.. All Rights Reserved. 
 *                                                                         
 *        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF THE               
 *                   SANTA CRUZ OPERATION INC.                             
 *                                                                         
 *   The copyright notice above does not evidence any actual or intended   
 *   publication of such source code.                                      
 */

#ifndef _SIGNAL_H
#define _SIGNAL_H
#ident	"@(#)sgs-head:common/head/signal.h	1.5.6.10"

typedef int 	sig_atomic_t;

#ifdef __cplusplus
extern "C" {
#endif

extern const char *const	_sys_siglist[];
extern const int		_sys_nsig;

extern void	(*signal(int, void (*)(int)))(int);
extern int	raise(int);

#if __STDC__ - 0 == 0 || defined(_XOPEN_SOURCE) \
	|| defined(_POSIX_SOURCE) || defined(_POSIX_C_SOURCE)

#include <sys/signal.h>
#include <sys/types.h>

extern int	kill(pid_t, int);
extern int	sigaction(int, const struct sigaction *, struct sigaction *);
extern int	sigaddset(sigset_t *, int);
extern int	sigdelset(sigset_t *, int);
extern int	sigemptyset(sigset_t *);
extern int	sigfillset(sigset_t *);
extern int	sigismember(const sigset_t *, int);
extern int	sigpending(sigset_t *);
extern int	sigprocmask(int, const sigset_t *, sigset_t *);
extern int	sigsuspend(const sigset_t *);

extern int	_thr_sigwait(const sigset_t *, int *);

#else /* copy <sys/signal.h> info for -Xc */

#define SIGABRT	6
#define SIGFPE	8
#define SIGILL	4
#define SIGINT	2
#define SIGSEGV	11
#define SIGTERM	15
#ifdef __cplusplus
#define SIG_DFL	((void(*)(int))0)
#define SIG_ERR	((void(*)(int))-1)
#define SIG_IGN	((void(*)(int))1)
#elif !#lint(on)
#define SIG_DFL	((void(*)())0)
#define SIG_ERR	((void(*)())-1)
#define SIG_IGN	((void(*)())1)
#else
#define SIG_DFL	((void(*)())0)
#define SIG_ERR	((void(*)())0)
#define SIG_IGN	((void(*)())0)
#endif

#endif /*__STDC__ - 0 == 0 || ...*/

#if defined(_XOPEN_SOURCE) && _XOPEN_SOURCE_EXTENDED - 0 >= 1 \
	|| _XOPEN_SOURCE - 0 >= 500 || _POSIX_C_SOURCE - 0 >= 199506 \
	|| __STDC__ - 0 == 0 && !defined(_XOPEN_SOURCE) \
	&& !defined(_POSIX_SOURCE) && !defined(_POSIX_C_SOURCE)

extern void	(*bsd_signal(int , void (*) (int)))(int); 
extern int	killpg(pid_t, int);
extern int	sigaltstack(const stack_t *, stack_t *);
extern int	sighold(int);
extern int	sigignore(int);
extern int 	siginterrupt(int, int);
extern int	sigpause(int);
extern int	sigrelse(int);
extern void	(*sigset(int, void (*)(int)))(int);

#endif /*defined(_XOPEN_SOURCE) && ...*/

#if defined(_XOPEN_SOURCE) && _XOPEN_SOURCE_EXTENDED - 0 >= 1 \
	|| _XOPEN_SOURCE - 0 >= 500 \
	|| __STDC__ - 0 == 0 && !defined(_XOPEN_SOURCE) \
	&& !defined(_POSIX_SOURCE) && !defined(_POSIX_C_SOURCE)
extern int	sigstack(struct sigstack *, struct sigstack *);
#endif

#if _XOPEN_SOURCE - 0 >= 500 || _POSIX_C_SOURCE - 0 >= 199506 \
	|| __STDC__ - 0 == 0 && !defined(_XOPEN_SOURCE) \
	&& !defined(_POSIX_SOURCE) && !defined(_POSIX_C_SOURCE)

extern int      pthread_kill(pthread_t, int);
extern int      pthread_sigmask(int, const sigset_t *, sigset_t *);

#if _XOPEN_SOURCE - 0 < 500 && _POSIX_C_SOURCE - 0 < 199506
extern int	sigwait(sigset_t *);
#elif defined(_EFTSAFE)
#define sigwait(sp,ip)	_thr_sigwait(sp,ip)
#else
#pragma weak _thr_sigwait
static int sigwait(const sigset_t *__1, int *__2) {
	return _thr_sigwait(__1, __2);
}
#endif

#endif /*_XOPEN_SOURCE - 0 >= 500 || ...*/

#if __STDC__ - 0 == 0 && !defined(_XOPEN_SOURCE) \
	&& !defined(_POSIX_SOURCE) && !defined(_POSIX_C_SOURCE)

#include <sys/procset.h>

extern int	gsignal(int);
extern void	(*sigset(int, void (*)(int)))(int);
extern int	(*ssignal(int, int (*)(int)))(int);
extern int	sigsend(idtype_t, id_t, int);
extern int	sigsendset(const procset_t *, int);

#endif /*__STDC__ - 0 == 0 && ...*/

#ifdef __cplusplus
}
#endif

#endif /*_SIGNAL_H*/
